{
  config,
  inputs,
  ...
}: {
  imports = with inputs; [
    self.nixosModules.config
    self.nixosModules.desktop
    self.nixosModules.system
    ./disko
    ./hardware
    ./misc
  ];

  networking = {
    networkmanager.enable = true;
    hostName = "legion";
  };

  environment.memoryAllocator.provider = "mimalloc";
  system.stateVersion = "25.11";
  time.timeZone = "Europe/Kyiv";

  desktop.niri.enable = true;

  module = {
    config = {
      laptop.homeRowMods = true;
      powerSave = true;
      # secureBoot = true;
      # tpmDiskUnlock = true;
      vaapi = "nvidia";
    };
    stylix = {
      enable = true;
      theme = "helios";
    };
  };

  locale.ukrainian.enable = true;
  virtual.libvirt.enable = true;
}
