{
  osConfig,
  config,
  inputs,
  pkgs,
  lib,
  ...
}: let
  inherit (lib) mkIf mkDefault getExe;
  inherit (config.lib.stylix) colors;
  inherit (osConfig.networking) hostName;
  ifLaptop = mkIf (hostName != "dunamis");
in {
  imports = with inputs; [
    walker.homeManagerModules.default
  ];
  options = config.desktop.hyprland.enable {
    # programs.fuzzel = import ./fuzzel {inherit config mkDefault;};
    programs.walker = import ./walker {inherit config inputs pkgs;};
    programs.waybar = import ./waybar {inherit colors config getExe ifLaptop pkgs;};
    programs.hyprlock = import ./hyprlock {inherit config pkgs;};
  };
}
