{
  config,
  pkgs,
  ...
}: let
  inherit (config.stylix) colors;
in {
  enable = true;
  settings = {
    general = {
      disable_loading_bar = true;
      #grace = 300;
      hide_cursor = true;
      no_fade_in = false;
    };

    background = [
      {
        path = "screenshot";
        blur_passes = 4;
        blur_size = 8;
      }
    ];

    input-field = [
      {
        size = "274, 50";
        rounding = 12;
        outline_thickness = 3;
        position = "0, 0";
        monitor = "";
        dots_center = true;
        fade_on_empty = false;
        font_family = "${config.stylix.fonts.serif.name}";
        font_color = "rgb(${colors.base05})";
        inner_color = "rgb(${colors.base00})";
        outer_color = "rgb(${colors.base0D})";
        check_color = "rgb(${colors.base0A})";
        fail_color = "rgb(${colors.base08})";
        placeholder_text = "locked...";
        fail_text = "wrong";
        shadow_passes = 0;
      }
    ];
    shape = [
      {
        rounding = 12;
        #border_size = 3;
        size = "274, 50";
        color = "rgb(${colors.base00})";
        border_color = "rgb(${colors.base0D})";
        position = "0, 60";
        halign = "center";
        valign = "center";
      }
      {
        rounding = 12;
        #border_size = 3;
        size = "274, 50";
        color = "rgb(${colors.base00})";
        border_color = "rgb(${colors.base0D})";
        position = "0, -60";
        halign = "center";
        valign = "center";
      }
    ];
    label = [
      {
        monitor = "";
        text = "$LAYOUT"; #"cmd[update:1000] ${pkgs.uutils-coreutils-noprefix}/bin/echo $(${pkgs.uutils-coreutils-noprefix}/bin/date +%H:%M:%S)";
        text_align = "center";
        font_size = 16;
        font_family = "${config.stylix.fonts.serif.name}";
        outer_color = "rgb(${colors.base00})";
        color = "rgb(${colors.base05})";
        position = "0, 60";
        halign = "center";
        valign = "center";
      }
      {
        monitor = "";
        text = "cmd[update:1000] ${pkgs.uutils-coreutils-noprefix}/bin/echo $(${pkgs.uutils-coreutils-noprefix}/bin/date +'%m/%d %a %T')";
        text_align = "center";
        font_size = 16;
        font_family = "${config.stylix.fonts.serif.name}";
        outer_color = "rgb(${colors.base00})";
        color = "rgb(${colors.base05})";
        position = "0, -60";
        halign = "center";
        valign = "center";
      }
    ];
  };
}
