{
  getExe,
  perSystem,
  pkgs,
  lockscreen,
  ...
}: {
  swaync = import ./swaync;
  network-manager-applet.enable = true;
  playerctld.enable = true;
  wpaperd.enable = true;
  copyq = {
    enable = true;
    package = perSystem.nixpkgs-stable.copyq;
  };
  gnome-keyring = {
    enable = true;
    components = ["secrets"];
  };
  gammastep = {
    enable = true;
    provider = "manual";
    latitude = 49.6;
    longitude = 36.1;
    tray = true;
    temperature = {
      day = 6500;
      night = 3000;
    };
  };
  swayosd = {
    enable = true;
    topMargin = 0.8;
  };
  udiskie = {
    enable = true;
    automount = false;
    notify = true;
    tray = "auto";
  };
  hypridle = {
    enable = true;
    settings = {
      general = {
        before_sleep_cmd = "loginctl lock-session";
        lock_cmd = "pidof ${lockscreen} || ${lockscreen}";
        # unlock_cmd = "loginctl unlock-session";
      };
      listener = [
        {
          timeout = 600;
          on-timeout = "pidof ${lockscreen} || ${lockscreen}";
        }
        {
          timeout = 601;
          on-timeout = getExe pkgs.niri + " msg action power-off-monitors";
        }
      ];
    };
  };
}
