{
  lib,
  pkgs,
  config,
  ...
}: let
  inherit (lib) mkEnableOption mkIf;
  cfg = config.module.desktop.gnome-keyring;
in {
  options = {
    module.desktop.gnome-keyring.enable = mkEnableOption "enable gnome keyring";
  };

  config = mkIf cfg.enable {
    environment.systemPackages = with pkgs; [
      gcr_4
      libsecret
    ];
    # programs.seahorse.enable = true;
    services.gnome.gnome-keyring.enable = true;
    xdg.portal.config.common = {
      "org.freedesktop.impl.portal.Secret" = ["gnome-keyring"];
    };
  };
}
