{
  config,
  pkgs,
  lib,
  ...
}:
with lib; let
  cfg = config.desktop.plasma;
in {
  imports = [
    ./common/pipewire.nix
  ];
  options = {
    desktop.plasma = {
      enable = mkEnableOption "enable plasma desktop";
    };
  };
  config = mkIf cfg.enable {
    module.desktop.displayManager = "sddm";
    sound.pipewire.enable = true;

    services.desktopManager.plasma6.enable = true;
    stylix.targets.qt.enable = mkDefault false;
  };
}
