{
  config,
  lib,
  ...
}: let
  inherit (lib) mkIf mkEnableOption;
  cfg = config.locale.ukrainian;
in {
  options = {
    locale.ukrainian.enable =
      mkEnableOption "enables ukrainian locale";
  };
  config = mkIf cfg.enable {
    i18n = let
      locale = "uk_UA.UTF-8";
    in {
      defaultLocale = locale;
      extraLocaleSettings = {
        LC_ADDRESS = locale;
        LC_COLLATE = "en_US.UTF-8";
        LC_CTYPE = locale;
        LC_IDENTIFICATION = locale;
        LC_MEASUREMENT = locale;
        LC_MESSAGES = locale;
        LC_MONETARY = locale;
        LC_NAME = locale;
        LC_NUMERIC = locale;
        LC_PAPER = locale;
        LC_TELEPHONE = locale;
        LC_TIME = locale;
      };
    };
  };
}
